/*
 * PM - 2017
 * proiect
 */
 
#include "lcd.h"
 
#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>

#define SUNET_LUNG		150
#define SUNET_SCURT		75
#define SUNET_PAUZA		50

/* Genereaza sunetul pentru tipul de ton folosit */
void speaker_sunet(int tip_sunet) {
	int i;

	/* Alternam starea pinului PD0 la fiecare milisecunda. */
	for (i = 0; i < tip_sunet; ++i) {
		PIND = (1 << PD0);

		_delay_ms(1);
	}
}

/* Aprinde led-uri la apasarea butoanelor */
void leds(void) {
	uint8_t level = -1;
	uint8_t count = 0;
	uint8_t flag = 0;
	uint8_t flag2 = -1;
	uint8_t flag3 = 0;
	
	/* Setez pini ca intrare. */
	DDRB &= ~(1 << PB0);
	DDRB &= ~(1 << PB1);
	DDRB &= ~(1 << PB2);
	DDRB &= ~(1 << PB3);

	/* Setez pini ca iesire. */
	DDRB |= (1 << PB4);
	DDRB |= (1 << PB5);
	DDRB |= (1 << PB6);
	DDRB |= (1 << PB7);
	
	/* Activez rezistenta de pull-up pentru pini de intrare */
	PORTB |= (1 << PB0);
	PORTB |= (1 << PB1);
	PORTB |= (1 << PB2);
	PORTB |= (1 << PB3);

	/* Sting LED-urile. */
	PORTB &= ~(1 << PB4);
	PORTB &= ~(1 << PB5);
	PORTB &= ~(1 << PB6);
	PORTB &= ~(1 << PB7);

	/* Setez pinul PD0 ca iesire. */
	DDRD |= (1 << PD0);

	/* Opresc speaker-ul. */
	PORTD &= ~(1 << PD0);
	while(1) {
		if (flag == 0) {
			if ((PINB & (1 << PB0)) == 0) {
				level = 1;
				flag = 1;
				PORTB ^= (1 << PB4);
				speaker_sunet(SUNET_SCURT);
				_delay_ms(250);
				PORTB &= ~(1 << PB4);
			}
			
			if ((PINB & (1 << PB1)) == 0) {
				level = 2;
				flag = 1;
				PORTB ^= (1 << PB5);
				speaker_sunet(SUNET_LUNG);
				_delay_ms(250);
				PORTB &= ~(1 << PB5);
			}
			
			if ((PINB & (1 << PB2)) == 0) {
				level = 3;
				flag = 1;
				PORTB ^= (1 << PB6);
				speaker_sunet(SUNET_SCURT);
				_delay_ms(250);
				PORTB &= ~(1 << PB6);
			}
			
			if ((PINB & (1 << PB3)) == 0) {
				level = 4;
				flag = 1;
				PORTB ^= (1 << PB7);
				speaker_sunet(SUNET_LUNG);
				_delay_ms(250);
				PORTB &= ~(1 << PB7);
			}
		}
		
		_delay_ms(150);
		
		if (flag2 != 1 && flag == 1) {
			switch(level) {
				case 1:
					PORTB ^= (1 << PB6);
					_delay_ms(200);
					PORTB ^= (1 << PB6);
					_delay_ms(200);
					PORTB ^= (1 << PB7);
					_delay_ms(200);
					PORTB ^= (1 << PB7);
					_delay_ms(200);
					PORTB ^= (1 << PB5);
					_delay_ms(200);
					PORTB ^= (1 << PB5);
					_delay_ms(200);
					flag2 = 1;
					break;
				case 2:
					PORTB ^= (1 << PB5);
					_delay_ms(100);
					PORTB ^= (1 << PB5);
					_delay_ms(100);
					PORTB ^= (1 << PB4);
					_delay_ms(100);
					PORTB ^= (1 << PB4);
					_delay_ms(100);
					PORTB ^= (1 << PB6);
					_delay_ms(100);
					PORTB ^= (1 << PB6);
					_delay_ms(100);
					PORTB ^= (1 << PB7);
					_delay_ms(100);
					PORTB ^= (1 << PB7);
					_delay_ms(100);
					flag2 = 1;
					break;
				case 3:
					PORTB ^= (1 << PB4);
					_delay_ms(100);
					PORTB ^= (1 << PB4);
					_delay_ms(100);
					PORTB ^= (1 << PB5);
					_delay_ms(100);
					PORTB ^= (1 << PB5);
					_delay_ms(100);
					PORTB ^= (1 << PB6);
					_delay_ms(100);
					PORTB ^= (1 << PB6);
					_delay_ms(100);
					PORTB ^= (1 << PB7);
					_delay_ms(100);
					PORTB ^= (1 << PB7);
					_delay_ms(100);
					PORTB ^= (1 << PB5);
					_delay_ms(100);
					PORTB ^= (1 << PB5);
					_delay_ms(100);
					PORTB ^= (1 << PB4);
					_delay_ms(100);
					PORTB ^= (1 << PB4);
					_delay_ms(100);
					flag2 = 1;
					break;
				case 4:
					PORTB ^= (1 << PB5);
					_delay_ms(150);
					PORTB ^= (1 << PB5);
					_delay_ms(150);
					PORTB ^= (1 << PB6);
					_delay_ms(150);
					PORTB ^= (1 << PB6);
					_delay_ms(150);
					PORTB ^= (1 << PB4);
					_delay_ms(150);
					PORTB ^= (1 << PB4);
					_delay_ms(150);
					PORTB ^= (1 << PB7);
					_delay_ms(150);
					PORTB ^= (1 << PB7);
					_delay_ms(150);
					PORTB ^= (1 << PB7);
					_delay_ms(150);
					PORTB ^= (1 << PB7);
					_delay_ms(150);
					PORTB ^= (1 << PB4);
					_delay_ms(150);
					PORTB ^= (1 << PB4);
					_delay_ms(150);
					PORTB ^= (1 << PB6);
					_delay_ms(150);
					PORTB ^= (1 << PB6);
					_delay_ms(150);
					PORTB ^= (1 << PB5);
					_delay_ms(150);
					PORTB ^= (1 << PB5);
					_delay_ms(150);
					flag2 = 1;
					break;
				default:
					break;
			}
		}
		
		while(flag2 == 1) {
			switch(level) {
				case 1:
					if ((PINB & (1 << PB0)) == 0) {
						count++;
						PORTB ^= (1 << PB4);
						speaker_sunet(SUNET_SCURT);
						_delay_ms(150);
						if (count != 0) {
								flag2 = 2;
								break;
						}
					}
				
					if ((PINB & (1 << PB1)) == 0) {
						count++;
						PORTB ^= (1 << PB5);
						speaker_sunet(SUNET_LUNG);
						_delay_ms(150);
						if (count != 3) {
								flag2 = 2;
								break;
						}
						
					}
				
					if ((PINB & (1 << PB2)) == 0) {
						count++;
						PORTB ^= (1 << PB6);
						speaker_sunet(SUNET_SCURT);
						_delay_ms(150);
						if (count != 1) {
								flag2 = 2;
								break;
						}
					}
				
					if ((PINB & (1 << PB3)) == 0) {
						count++;
						PORTB ^= (1 << PB7);
						speaker_sunet(SUNET_LUNG);
						_delay_ms(150);
						if (count != 2) {
								flag2 = 2;
								break;
						}
					}
					
					if (count >= 3) {
						PORTB &= ~(1 << PB4);
						PORTB &= ~(1 << PB5);
						PORTB &= ~(1 << PB6);
						PORTB &= ~(1 << PB7);
						_delay_ms(250);
						PORTB ^= (1 << PB4);
						PORTB ^= (1 << PB5);
						PORTB ^= (1 << PB6);
						PORTB ^= (1 << PB7);
						_delay_ms(250);
						PORTB &= ~(1 << PB4);
						PORTB &= ~(1 << PB5);
						PORTB &= ~(1 << PB6);
						PORTB &= ~(1 << PB7);
						flag = 0;
						flag2 = -1;
						count = 0;
						break;
					}
					break;
				case 2: 
					if ((PINB & (1 << PB0)) == 0) {
						count++;
						PORTB ^= (1 << PB4);
						speaker_sunet(SUNET_SCURT);
						_delay_ms(150);
						if (count != 2) {
								flag2 = 2;
								break;
						}
					}
				
					if ((PINB & (1 << PB1)) == 0) {
						count++;
						PORTB ^= (1 << PB5);
						speaker_sunet(SUNET_LUNG);
						_delay_ms(150);
						if (count != 1) {
								flag2 = 2;
								break;
						}
					}
				
					if ((PINB & (1 << PB2)) == 0) {
						count++;
						PORTB ^= (1 << PB6);
						speaker_sunet(SUNET_SCURT);
						_delay_ms(150);
						if (count != 3) {
								flag2 = 2;
								break;
						}
					}
				
					if ((PINB & (1 << PB3)) == 0) {
						count++;
						PORTB ^= (1 << PB7);
						speaker_sunet(SUNET_LUNG);
						_delay_ms(150);
						if (count != 4) {
								flag2 = 2;
								break;
						}
					}
					
					if (count >= 4) {
						PORTB &= ~(1 << PB4);
						PORTB &= ~(1 << PB5);
						PORTB &= ~(1 << PB6);
						PORTB &= ~(1 << PB7);
						_delay_ms(250);
						PORTB ^= (1 << PB4);
						PORTB ^= (1 << PB5);
						PORTB ^= (1 << PB6);
						PORTB ^= (1 << PB7);
						_delay_ms(250);
						PORTB &= ~(1 << PB4);
						PORTB &= ~(1 << PB5);
						PORTB &= ~(1 << PB6);
						PORTB &= ~(1 << PB7);
						flag = 0;
						flag2 = -1;
						count = 0;
						break;
					}
				case 3:
					if ((PINB & (1 << PB0)) == 0) {
						count++;
						PORTB ^= (1 << PB4);
						speaker_sunet(SUNET_SCURT);
						_delay_ms(150);
						if (flag3 == 0) {
							if (count != 1) {
									flag2 = 2;
									break;
							}
						}
						if (flag3 == 1) {
								if (count != 6) {
									flag2 = 2;
									break;
								}
						}
					}
				
					if ((PINB & (1 << PB1)) == 0) {
						count++;
						PORTB ^= (1 << PB5);
						speaker_sunet(SUNET_LUNG);
						_delay_ms(150);
						if (flag3 == 0) {
							if (count != 2) {
									flag2 = 2;
									break;
							}
						}
						if (flag3 == 1) {
								if (count != 5) {
									flag2 = 2;
									break;
								}
						}						
					}
				
					if ((PINB & (1 << PB2)) == 0) {
						count++;
						PORTB ^= (1 << PB6);
						speaker_sunet(SUNET_SCURT);
						_delay_ms(150);
						if (count != 3) {
								flag2 = 2;
								break;
						}
					}
				
					if ((PINB & (1 << PB3)) == 0) {
						count++;
						PORTB ^= (1 << PB7);
						speaker_sunet(SUNET_LUNG);
						_delay_ms(150);
						if (count != 4) {
								flag2 = 2;
								break;
						} else {
								flag3 = 1;
						}
					}
					
					if (count >= 6) {
						PORTB &= ~(1 << PB4);
						PORTB &= ~(1 << PB5);
						PORTB &= ~(1 << PB6);
						PORTB &= ~(1 << PB7);
						_delay_ms(250);
						PORTB ^= (1 << PB4);
						PORTB ^= (1 << PB5);
						PORTB ^= (1 << PB6);
						PORTB ^= (1 << PB7);
						_delay_ms(250);
						PORTB &= ~(1 << PB4);
						PORTB &= ~(1 << PB5);
						PORTB &= ~(1 << PB6);
						PORTB &= ~(1 << PB7);
						flag = 0;
						flag2 = -1;
						flag3 = 0;
						count = 0;
						break;
					}
					break;
				case 4:
					if ((PINB & (1 << PB0)) == 0) {
						count++;
						PORTB ^= (1 << PB4);
						speaker_sunet(SUNET_SCURT);
						_delay_ms(150);
						if (flag3 == 0) {
							if (count != 3) {
									flag2 = 2;
									break;
							}
						}
						if (flag3 == 1) {
								if (count != 6) {
									flag2 = 2;
									break;
								}
						}
					}
				
					if ((PINB & (1 << PB1)) == 0) {
						count++;
						PORTB ^= (1 << PB5);
						speaker_sunet(SUNET_LUNG);
						_delay_ms(150);
						if (flag3 == 0) {
							if (count != 1) {
									flag2 = 2;
									break;
							}
						}
						if (flag3 == 1) {
								if (count != 8) {
									flag2 = 2;
									break;
								}
						}						
					}
				
					if ((PINB & (1 << PB2)) == 0) {
						count++;
						PORTB ^= (1 << PB6);
						speaker_sunet(SUNET_SCURT);
						_delay_ms(150);
						if (flag3 == 0) {
							if (count != 2) {
									flag2 = 2;
									break;
							}
						}
						if (flag3 == 1) {
								if (count != 7) {
									flag2 = 2;
									break;
								}
						}
					}
				
					if ((PINB & (1 << PB3)) == 0) {
						count++;
						PORTB ^= (1 << PB7);
						speaker_sunet(SUNET_LUNG);
						_delay_ms(150);
						if (flag3 == 1) {
								if (count != 5) {
									flag2 = 2;
									break;
								}
						}
						if (flag3 == 0) {
							if (count != 4) {
									flag2 = 2;
									break;
							} else {
								flag3 = 1;
							}
						}
					}
					
					if (count >= 8) {
						PORTB &= ~(1 << PB4);
						PORTB &= ~(1 << PB5);
						PORTB &= ~(1 << PB6);
						PORTB &= ~(1 << PB7);
						_delay_ms(250);
						PORTB ^= (1 << PB4);
						PORTB ^= (1 << PB5);
						PORTB ^= (1 << PB6);
						PORTB ^= (1 << PB7);
						_delay_ms(250);
						PORTB &= ~(1 << PB4);
						PORTB &= ~(1 << PB5);
						PORTB &= ~(1 << PB6);
						PORTB &= ~(1 << PB7);
						flag = 0;
						flag2 = -1;
						flag3 = 0;
						count = 0;
						break;
					}
					break;
				default:
					break;
			}
			if (flag2 == 2)
				break;
		}
		if (flag2 == 2)
			break;
	}
}

/*
void lcd()
{
    // configurare porturi folosite
    DDRB &= ~(1 << PB0);
    DDRB &= ~(1 << PB1);
    PORTB |= (1 << PB0);
    PORTB |= (1 << PB1);

    // initializari
    char str[] = "Select Level";
    LCD_print(str);

    // main loop
    int8_t pos = 0;
    uint8_t PINB_old = 0xff;
    for(;;)
    {
        uint8_t PINB_crt = PINB;

        if((PINB_old & (1 << PB0)) && !(PINB_crt & (1 << PB0)))
        {
            pos += 1;
            if(pos + (sizeof(str) - 1) > 16)
                pos = 16 - (sizeof(str) - 1);

            LCD_writeInstr(LCD_INSTR_clearDisplay);
            LCD_printAt(pos, str);
        }

        if((PINB_old & (1 << PB1)) && !(PINB_crt & (1 << PB1)))
        {
            pos -= 1;
            if(pos < 0)
                pos = 0;

            LCD_writeInstr(LCD_INSTR_clearDisplay);
            LCD_printAt(pos, str);
        }

        PINB_old = PINB_crt;

        _delay_ms(5);
    }
}
*/

int main(void) {
	// LCD_init();
	
	leds();
	//lcd();
	
	//LCD_print("Hello World!");
	//for(;;);
	
	while (1);

	return 0;
}
